-- name: Big Paddle
-- description: Press DPAD+down to spawn a Big Paddle

E_MODEL_BIG_PADDLE = smlua_model_util_get_id("Umbrella_geo")

COL_BIG_PADDLE = smlua_collision_util_get("nil")

----------------------------------
define_custom_obj_fields(
    {
        oOwner = 'u32',
    }
)
function bhv_big_umbrella_init(obj)
    obj.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    obj.oCollisionDistance = 1000
    obj.collisionData = COL_BIG_PADDLE
    network_init_object(obj, false, nil)
end


function bhv_big_umbrella_loop(obj)

    local m = gMarioStates[obj.oOwner]
    local up = -80
    local front = 0
    local side = 0
    
    local limb = 0

    local yawSin = sins(m.marioObj.header.gfx.angle.y)
    local yawSideSin = sins(m.marioObj.header.gfx.angle.y - 0x4000)

    local yawCos = coss(m.marioObj.header.gfx.angle.y)
    local yawSideCos = coss(m.marioObj.header.gfx.angle.y - 0x4000)

    local pitchSin = sins(m.marioObj.header.gfx.angle.x)
    local pitchCos = coss(m.marioObj.header.gfx.angle.x)


    obj.oPosX = get_hand_foot_pos_x(m, limb) + side
    obj.oPosY = get_hand_foot_pos_y(m, limb) + up
    obj.oPosZ = get_hand_foot_pos_z(m, limb) + front


    obj.header.gfx.pos.x = obj.oPosX
    obj.header.gfx.pos.y = obj.oPosY
    obj.header.gfx.pos.z = obj.oPosZ 
    obj.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE

    if m.action ~= ACT_BIG_GLIDE  then 
        obj_mark_for_deletion(obj)
  
    end
end

id_bhvBigumbrella = hook_behavior(nil, OBJ_LIST_DEFAULT, false, bhv_big_umbrella_init, bhv_big_umbrella_loop)

----------------------------------

---@param o Object
